///////////////////////////////////////////////////////////////////////////////
///     @file   main.cpp
///     @author Thomas Seban
///     @date   Mai 2008
///////////////////////////////////////////////////////////////////////////////

#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>

#include "gp2x.h"
#include "fwSDLLog.h"
#include "fwSDLApp.h"

#ifdef DEBUG_MEM
#include "lib\Debug\nvwa\debug_new.h"
#endif

class TestApp : public SDLApp {
    protected:
        Mix_Music *music;
        void InternalInit();
        void InternalAfterDrawScene(SDL_Surface *Screen);
    public:
        TestApp();
        ~TestApp();

};

void TestApp::InternalInit() {
    music = Mix_LoadMUS("music.ogg");

    Mix_PlayMusic(music, 1);
}

void TestApp::InternalAfterDrawScene(SDL_Surface *Screen) {
    if (KeyPressed(SDLK_x)) {
        Stop();
    }
}

TestApp::TestApp() {
    music = NULL;
}

TestApp::~TestApp() {
    Mix_FreeMusic(music);
}

int main( int argc, char* args[] )
{
    TestApp App;

    try {
        App.SetCommandLine(argc, args);
        App.Init();
        App.Run();
    }
    catch (char* eMessage) {
        Log.Add(eMessage);
    }

    return 0;
}
